org.apache.bcel.verifier

## Class PassVerifier

- java.lang.Object
- - org.apache.bcel.verifier.PassVerifier

- Direct Known Subclasses:
    Pass1Verifier, Pass2Verifier, Pass3aVerifier, Pass3bVerifier

      public abstract class PassVerifier
      extends Object

  A PassVerifier actually verifies a class file; it is instantiated by a Verifier. The verification should conform with a certain pass as described in The Java Virtual Machine Specification, 2nd edition. This book describes four passes. Pass one means loading the class and verifying a few static constraints. Pass two actually verifies some other constraints that could enforce loading in referenced class files. Pass three is the first pass that actually checks constraints in the code array of a method in the class file; it has two parts with the first verifying static constraints and the second part verifying structural constraints (where a data flow analysis is used for). The fourth pass, finally, performs checks that can only be done at run-time. JustIce does not have a run-time pass, but certain constraints that are usually delayed until run-time for performance reasons are also checked during the second part of pass three. PassVerifier instances perform caching. That means, if you really want a new verification run of a certain pass you must use a new instance of a given PassVerifier.
  Version:
    $Id: PassVerifier.java 1806200 2017-08-25 16:33:06Z ggregory $
  See Also:
    `Verifier`, `verify()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PassVerifier()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addMessage(String message)` This method adds a (warning) message to the message pool of this PassVerifier.
    `abstract VerificationResult` | `do_verify()` Does the real verification work, uncached.
    `String[]` | `getMessages()` Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
    `VerificationResult` | `verify()` This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PassVerifier

          public PassVerifier()

  - ### Method Detail

    - #### verify

          public VerificationResult verify()

      This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file. PassVerifier instances perform caching; i.e. if the verify() method once determined a VerificationResult, then this result may be returned after every invocation of this method instead of running the verification pass anew; likewise with the result of getMessages().
      See Also:
        `getMessages()`, `addMessage(String)`

    - #### do_verify

          public abstract VerificationResult do_verify()

      Does the real verification work, uncached.

    - #### addMessage

          public void addMessage(String message)

      This method adds a (warning) message to the message pool of this PassVerifier. This method is normally only internally used by BCEL's class file verifier "JustIce" and should not be used from the outside.
      See Also:
        `getMessages()`

    - #### getMessages

          public String[] getMessages()

      Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
      See Also:
        `addMessage(String)`, `do_verify()`

Copyright © 2004–2017 The Apache Software Foundation. All rights reserved.